Update an Estimate Subcategory
Edit an existing estimate subcategory in your ConstructionOnline company account
https://api.constructiononline.com/api/v2/EstimateSubCategories?subcatID={subcatID}
This endpoint allows users to edit an existing estimate subcategory within an estimate in their ConstructionOnline company account. To update an estimate subcategory, users must know the unique numerical ID assigned to the subcategory. The estimate subcategory's ID is stored in the property 'ID'. Only the properties specified in the request body will be updated; the other properties will remain as is. This endpoint cannot be used to update items within the estimate subcategory. This endpoint will also not update any locked fields within the ConstructionOnline estimate.
Requests
subcatID: integer
- Unique identifier for the estimate subcategory.
Subcategory Info: JSON
- Updated properties for the subcategory.
- Allowed properties: NAME, DESCRIPTION, COST_CODE, COST_CODE_ID, TRAFFIC_COLOR, CLASSIFICATION, STATUS, COST_ESTIMATE, LINE_ITEM_MARKUP, COMMITTED_COSTS, INVOICED_AMOUNTS, ACTUAL, RATE, RATE_QTY, LINE_ITEM_MARKUP_TYPE, FIVE_COLUMN_EQUIPMENT, FIVE_COLUMN_LABOR, FIVE_COLUMN_MATERIAL, FIVE_COLUMN_OTHER, FIVE_COLUMN_SUB, UNIT_NAME, UNIT, ADJUSTMENT, BID_NOTES, NOTES_TEAMLINK, NOTES_BID, FIELD_NOTES, NOTES_CLIENTLINK, NOTES_FIELD, GENERAL_NOTES, NOTES_GENERAL
Individual properties for update should be entered as JSON key-value pairs, as seen below:
{
"QTY": 2600,
"UNIT_COST": 7.10
}
Example requests in cURL, C#, Python, and JavaScript can be found below:
cURL
# replace {email} with the email address for your ConstructionOnline account
# {password} with your ConstructionOnline password
# {apikey} with your provided API key
# {subcatID} with the estimate subcategory's ID
curl -X PUT https://api.constructiononline.com/api/v2/EstimateSubCategories?subcatID={subcatID} -u {email}:{password} -H 'APIKey:{apikey}'
C#
/* replace {username} with the email address for your ConstructionOnline account
{password} with your ConstructionOnline password
{apikey} with your provided API key
{subcatID} with the estimate subcategory's ID */
public string MakeRequest(string endpoint, string payload) {
string username = {username};
string password = {password};
string apiKey = {apikey};
string response = "";
var handler = new HttpClientHandler() { AutomaticDecompression = System.Net.DecompressionMethods.GZip };
using (HttpClient client = new HttpClient(handler)) {
client.BaseAddress = new Uri("http://api.constructiononline.com");
client.DefaultRequestHeaders.Accept.Clear();
client.DefaultRequestHeaders.Accept.Add(new MediaTypeWithQualityHeaderValue("application/json"));
client.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", System.Convert.ToBase64String(System.Text.Encoding.GetEncoding("ISO-8859-1").GetBytes(username + ":" + password)));
client.DefaultRequestHeaders.Add("APIKey", apiKey);
client.DefaultRequestHeaders.Add("Accept-Encoding", "gzip");
HttpContent content = new StringContent(payload, System.Text.Encoding.UTF32, "application/json");
response = client.PutAsync(endpoint, content).Result.ToString();
}
return response;
}
MakeRequest("api/v2/EstimateSubCategories?subcatID={subcatID}");
Python
#replace {username} with the email address for your ConstructionOnline account
#{password} with your ConstructionOnline password
#{apikey} with your provided API key
#{subcatID} with the estimate subcategory's ID
import base64, requests, json
#Global Variables
apikey = {apikey}
username = {username}
password = {password}
#Functions
def makeRequest(endpoint, payload):
url = "https://api.constructiononline.com/" + endpoint
userPass = username + ":" + password
headers = {
"APIKey": apikey,
"Accept-Encoding": "gzip, deflate, br",
"Authorization": "Basic " + base64.b64encode(userPass.encode()).decode(),
}
response = requests.request("PUT", url, headers=headers, data=payload)
return json.dumps(json.loads(response.text), indent=2)
#Main Program
print(makeRequest("api/v2/EstimateSubCategories?subcatID={subcatID}"))
JavaScript
/* replace {username} with the email address for your ConstructionOnline account
{password} with your ConstructionOnline password
{apikey} with your provided API key
{subcatID} with the estimate subcategory's ID */
username = '{username}';
password = '{password}';
apikey = '{apikey}';
function makeRequest(endpoint, payload) {
auth = btoa('${username}:${password}');
var myHeaders = new Headers();
myHeaders.append("APIKey", apikey);
myHeaders.append("Accept-Encoding", "gzip, deflate, br");
myHeaders.append("Authorization", "Basic ${auth}");
var requestOptions = {
method: 'PUT',
body: '',
headers: myHeaders,
redirect: 'follow'
};
fetch("https://api.constructiononline.com/" + endpoint, requestOptions)
.then(response => response.text())
.then(result => console.log(result))
.catch(error => console.log('error', error));
return response;
};
makeRequest("api/v2/EstimateSubCategories?subcatID={subcatID}");
Responses
200: Success
A successful request will return a 200 response with a record of the edited estimate subcategory in the body.
A sample response and property definitions can be found here.
404: Error
The server was not able to locate the resource specified in the request. The ID may have been entered incorrectly or an estimate subcategory with the entered ID does not exist.
429: Error
The user has surpassed the request rate limit for the hour, day, week, or month.
500: Error
There was an internal server error and the server was unable to complete the request.
Last updated: Sep 22, 2026